unit MyIsamTest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtCtrls, StdCtrls,
  ComCtrls, FileCtrl, Grids, MyIsam;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    btnFirst: TButton;
    btnNext: TButton;
    btnPrior: TButton;
    btnLast: TButton;
    btnDelete: TButton;
    TabSheet3: TTabSheet;
    TextName: TEdit;
    IsamName: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    btnLoad: TButton;
    btnUnload: TButton;
    RecSize: TEdit;
    Label10: TLabel;
    KeySize: TEdit;
    Label11: TLabel;
    KeyPos: TEdit;
    Label12: TLabel;
    IsamFile: TEdit;
    btnOpen: TButton;
    btnBuild: TButton;
    btnErase: TButton;
    btnInfo: TButton;
    Label14: TLabel;
    eKey: TEdit;
    eRecNo: TEdit;
    Label6: TLabel;
    btnSeek: TButton;
    btnPost: TButton;
    btnSearch: TButton;
    btnInsert: TButton;
    TabView: TTabSheet;
    StringGrid2: TStringGrid;
    Panel2: TPanel;
    Edit1: TEdit;
    Label2: TLabel;
    btnView: TButton;
    eRec: TMemo;
    btnAppend: TButton;
    Isam1: TMyIsam;
    Msg: TPanel;
    btnRebuild: TButton;


    procedure SetDisplay;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure btnUnloadClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPriorClick(Sender: TObject);
    procedure btnLastClick(Sender: TObject);
    procedure btnSeekClick(Sender: TObject);
    procedure btnBuildClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnEraseClick(Sender: TObject);
    procedure btnInfoClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnPostClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure btnInsertClick(Sender: TObject);
    procedure btnViewClick(Sender: TObject);
    procedure btnAppendClick(Sender: TObject);
    procedure btnRebuildClick(Sender: TObject);
    procedure eKeyExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  rec: string;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  if ParamCount > 0 then
     begin
      Edit1.Text := ParamStr(1);
      IsamName.Text := Edit1.Text;
      IsamFile.Text := Edit1.Text;
      IsamFile.Text := Edit1.Text;
      Textname.Text := Edit1.Text+'.txt';
     end;

  Msg.Caption := '';
  PageControl1.ActivePage := TabSheet1;
  SetDisplay;
  Msg.Caption:=Isam1.ErrMsg;
end;

procedure TForm1.SetDisplay;
begin
  eRec.Text:=Rec;
  eKey.Text   := Copy(Rec,Isam1.KeyPos,Isam1.KeySize);
  eRecNo.Text := IntToStr(Isam1.CurRec);
  btnFirst.Enabled := Isam1.Active;
  btnNext.Enabled := Isam1.Active;
  btnPrior.Enabled := Isam1.Active;
  btnLast.Enabled := Isam1.Active;
  btnSearch.Enabled := Isam1.Active;
  btnSeek.Enabled := Isam1.Active;
  btnDelete.Enabled := Isam1.Active;
  btnPost.Enabled := Isam1.Active;
  btnInsert.Enabled := Isam1.Active;
  btnAppend.Enabled := Isam1.Active;

  if Isam1.ErrNo <> ISERR_OK then
     Msg.Caption:='Error#'+IntToStr(Isam1.ErrNo)+': '+Isam1.ErrMsg;
end;

procedure TForm1.btnBuildClick(Sender: TObject);
begin
  if Isam1.Build(IsamName.Text,StrToInt(RecSize.Text),StrToInt(KeySize.Text),StrToInt(KeyPos.Text)) then
     Msg.Caption:='Isam file built'
  else
     Msg.Caption:=Isam1.ErrMsg;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Isam1.Close;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.btnInfoClick(Sender: TObject);
var
 s: string;
begin
  s :=
     ' Filename='+Isam1.Filename+
     ' DataSize='+IntToStr(Isam1.DataSize)+
     ' KeySize='+IntToStr(Isam1.KeySize)+
     ' KeyPos='+IntToStr(Isam1.KeyPos) +#13+
     ' Records='+IntToStr(Isam1.Records)+
     ' Key='''+Copy(Rec,Isam1.KeyPos,Isam1.KeySize)+''''+
     ' RecNo='+IntToStr(Isam1.CurRec)+#13+
     ' ErrNo='+IntToStr(Isam1.ErrNo)+
     ' ErrMsg='+Isam1.ErrMsg+#13;

  if Isam1.Active then
     s:=s+' Active=True'
  else
     s:=s+' Active=False';

  if Isam1.EOF then
     s:=s+' EOF=True '
  else
     s:=s+' EOF=False';

  if Isam1.Changed then
     s:=s+' Changed=True '
  else
     s:=s+' Changed=False';

  ShowMessage(s);
end;

procedure TForm1.btnLoadClick(Sender: TObject);
var
 c: integer;
begin
  Isam1.Open(IsamName.Text);
  c := Isam1.Load(Textname.Text);
  if Isam1.ErrNo = ISERR_OK then
     Msg.Caption:='Loaded '+IntToStr(c)+ ' records.'
  else
     Msg.Caption := Isam1.ErrMsg;
  Isam1.Close;
end;

procedure TForm1.btnOpenClick(Sender: TObject);
begin
  if btnOpen.Caption = 'Open' then
     begin
      if Isam1.Open(IsamFile.Text) = False then
         begin
          Msg.Caption := Isam1.ErrMsg;
          exit;
         end;
      btnOpen.Caption := 'Close';
      TabSheet3.TabVisible := False;
      TabView.TabVisible := False;
      RecSize.Text := IntToStr(Isam1.DataSize);
      KeySize.Text := IntToStr(Isam1.KeySize);
      KeyPos.Text  := IntToStr(Isam1.KeyPos);
      IsamFile.Text := Isam1.Filename;
      Edit1.Text := Isam1.Filename;
      Textname.Text := Isam1.Filename+'.txt';
      btnFirstClick(Sender);
     end
  else
     begin
      Isam1.Close;
      btnOpen.Caption := 'Open';
      TabSheet3.TabVisible := True;
      TabView.TabVisible := True;
      Msg.Caption := Isam1.Filename+' Closed!';
     end;

  SetDisplay;
end;

procedure TForm1.btnUnloadClick(Sender: TObject);
var
 c: integer;
begin
  Isam1.Open(IsamName.Text);
  c := Isam1.UnLoad(Textname.Text);
  if Isam1.ErrNo = ISERR_OK then
     Msg.Caption:='Unloaded '+IntToStr(c)+ ' records.'
  else
     Msg.Caption := Isam1.ErrMsg;
  Isam1.Close;
end;

procedure TForm1.btnFirstClick(Sender: TObject);
begin
  Msg.Caption := 'First Record';
  Isam1.Read(Rec, ISFIRST);
  SetDisplay;
end;

procedure TForm1.btnNextClick(Sender: TObject);
begin
  Msg.Caption := 'Next Record';
  Isam1.Read(Rec, ISNEXT);
  SetDisplay
end;

procedure TForm1.btnPriorClick(Sender: TObject);
begin
  Msg.Caption := 'Prior record';
  Isam1.Read(Rec, ISPRIOR);
  SetDisplay
end;

procedure TForm1.btnLastClick(Sender: TObject);
begin
  Msg.Caption := 'Last record';
  Isam1.Read(Rec, ISLAST);
  SetDisplay;
end;

procedure TForm1.btnSeekClick(Sender: TObject);
begin
  Msg.Caption := 'Record found';
  Isam1.SeekRec(StrToInt(eRecno.Text),Rec);
  SetDisplay;
end;

procedure TForm1.btnSearchClick(Sender: TObject);
begin
  Msg.Caption := 'Key found';
//  Isam1.Search(eKey.Text,Rec);
  Rec := ERec.Text;
  Isam1.Read(Rec,ISKEY);
  SetDisplay;
end;

procedure TForm1.btnEraseClick(Sender: TObject);
begin
  if Isam1.Remove(IsamName.Text) = True then
     Msg.Caption := IsamName.Text + ' removed.'
  else
     Msg.Caption := Isam1.ErrMsg;
end;

procedure TForm1.btnPostClick(Sender: TObject);
begin
  Msg.Caption := 'Record#'+IntToStr(Isam1.CurRec)+' updated.';
  Rec:=eRec.Text;
  Isam1.Write(Rec,ISUPDATE);
  SetDisplay;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
  Msg.Caption := 'Record#'+IntToStr(Isam1.CurRec)+' deleted.';
  Isam1.Delete(Rec);
  SetDisplay;
end;

procedure TForm1.btnInsertClick(Sender: TObject);
begin
  Msg.Caption := 'Record#'+IntToStr(Isam1.CurRec)+' inserted.';
  Rec:=eRec.Text;
  Isam1.Write(Rec,ISINSERT);
  SetDisplay;
end;

procedure TForm1.btnViewClick(Sender: TObject);
begin
  Isam1.Open(Edit1.Text);
  Msg.Caption := Isam1.Setgrid(StringGrid2);
  Isam1.Close;
end;

procedure TForm1.btnAppendClick(Sender: TObject);
begin
  Msg.Caption := 'Record#'+IntToStr(Isam1.CurRec)+' appended.';
  Rec:=eRec.Text;
  Isam1.Write(Rec,ISAPPEND);
  SetDisplay;
end;

procedure TForm1.btnRebuildClick(Sender: TObject);
var
 c: integer;
begin
  c := Isam1.ReBuild(IsamName.Text);
  if Isam1.ErrNo = ISERR_OK then
     Msg.Caption:='Isam file rebuilt, records = '+IntToStr(c)
  else
     Msg.Caption:=Isam1.ErrMsg;
end;

procedure TForm1.eKeyExit(Sender: TObject);
begin
  Msg.Caption := 'Key found';
  Isam1.Search(eKey.Text,Rec);
  SetDisplay;
end;

end.
